// LENSE FLARES for some lights
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 1, binding = 0, std140) uniform _152_154
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
} _154;

layout(set = 2, binding = 0, std140) uniform _159_161
{
    vec4 _m0;
    vec4 _m1;
} _161;

layout(set = 0, binding = 0, std140) uniform _170_172
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
} _172;

layout(push_constant, std430) uniform _347_349
{
    int _m0;
    int _m1;
} _349;

layout(set = 0, binding = 1) uniform sampler2D _276;
layout(set = 2, binding = 1) uniform sampler2D _350;
layout(set = 2, binding = 2) uniform sampler2D _351;

layout(location = 0) in vec4 _111;
layout(location = 13) in uvec4 _130;
layout(location = 2) out vec4 _142;
layout(location = 1) in vec2 _144;
layout(location = 0) out vec4 _147;
layout(location = 3) in vec4 _148;
layout(location = 12) in vec2 _190;

float _13(float _12)
{
    return _12 * ((_12 * ((_12 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec3 _19(vec3 _18)
{
    float _56 = _18.x;
    vec3 _55;
    _55.x = _13(_56);
    float _63 = _18.y;
    _55.y = _13(_63);
    float _69 = _18.z;
    _55.z = _13(_69);
    return _55;
}

vec4 _25(vec4 _24)
{
    vec3 _79 = _24.xyz;
    vec4 _78 = vec4(_19(_79), 1.0);
    float _87 = _24.w;
    _78.w = _13(_87);
    return _78;
}

float _34(float _30, vec4 _31, float _32, bool _33)
{
    float _96 = _31.w / (_30 + _31.z);
    return _96 * _32;
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    vec4 _109 = vec4(_111.xy, 0.0, 1.0);
    gl_Position = _109;
    float _127 = float(_130.x) / 256.0;
    float _137 = float(_130.y) / 256.0;
    _142 = _144.xyxy;
    vec4 _149 = _148;
    _147 = ((((_25(_149) * _154._m0) * _161._m0.x) * _154._m1.x) * vec4(_172._m0.xxx, 1.0)) * vec4(vec3(_127), 1.0);
    vec2 _189 = (_190 * 0.5) + vec2(0.5);
    _189.y = 1.0 - _189.y;
    _189 *= _172._m1.xy;
    float _208 = _111.z;
    vec4 _212 = _172._m2;
    float _215 = 1.0;
    bool _216 = true;
    float _205 = _34(_208, _212, _215, _216) - _137;
    int _221 = 3;
    float _223 = 1.0 / float(((_221 * 2) + 1) * ((_221 * 2) + 1));
    float _233 = 0.0;
    for (int _234 = -_221; _234 <= _221; _234++)
    {
        for (int _245 = -_221; _245 <= _221; _245++)
        {
            vec2 _256 = ((vec2(float(_245), float(_234)) * _172._m3.zw) * _172._m1.xy) + _189;
            float _272 = textureLod(_276, vec4(_256, 0.0, 0.0).xy, vec4(_256, 0.0, 0.0).w).x;
            float _291 = _272;
            vec4 _293 = _172._m2;
            float _296 = 1.0;
            bool _297 = true;
            float _290 = _34(_291, _293, _296, _297);
            _233 += ((_290 > _205) ? _223 : 0.0);
        }
    }
    float _310 = _233;
    _147.w *= _10(_310);
    if (true)
    {
        float _320 = 0.0039215688593685626983642578125;
        float _322 = 1.0 / (1.0 - _320);
        if (_147.w < _320)
        {
            gl_Position = vec4(vec3(0.0).x, vec3(0.0).y, vec3(0.0).z, gl_Position.w);
        }
        _147.w = (_147.w - _320) * _322;
    }
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x ;//* (_147.w - vk3d_params[VIEW].stereo.y); 
}





