// HAIR
#version 450
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, std140) uniform _74_76
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _76;

layout(set = 1, binding = 0, std140) uniform _97_99
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
} _99;

layout(set = 0, binding = 1, std430) restrict readonly buffer _124_126
{
    vec4 _m0[];
} _126;

layout(set = 0, binding = 0, std140) uniform _327_329
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
} _329;

layout(push_constant, std430) uniform _1860_1862
{
    int _m0;
    int _m1;
} _1862;

layout(set = 1, binding = 1) uniform sampler2D _1866;
layout(set = 2, binding = 1) uniform sampler2D _1867;
layout(set = 2, binding = 2) uniform sampler2D _1868;

layout(location = 0) in vec4 _67;
layout(location = 3) in vec4 _107;
layout(location = 9) in vec4 _147;
layout(location = 2) in vec4 _163;
layout(location = 2) out vec4 _435;
layout(location = 1) in vec2 _438;
layout(location = 4) in vec2 _443;
layout(location = 8) out vec4 _452;
layout(location = 9) out vec4 _842;
layout(location = 3) out vec4 _1152;
layout(location = 4) out vec4 _1450;
layout(location = 12) in vec2 _1844;
layout(location = 7) out vec4 _1851;

float _28(vec4 _26, vec4 _27)
{
    return dot(_26, _27);
}

mat4 _35(mat4 _33, mat4 _34)
{
    return _33 * _34;
}

float _17(vec3 _15, vec3 _16)
{
    return dot(_15, _16);
}

float _24(vec4 _22, vec4 _23)
{
    return dot(_22.xyz, _23.xyz);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

void main()
{
    vec4 _65 = vec4(_67.xyz, 1.0);
    if (_76._m0.z != 0.0)
    {
        vec4 _88 = _65;
        vec4 _90 = vec4(0.0);
        vec4 _92 = vec4(0.0);
        vec4 _93 = vec4(0.0);
        uvec4 _96 = uvec4(uint(_99._m0.x + _76._m0.x)) + uvec4(_107 * 255.0);
        if (_76._m0.z == 1.0)
        {
            uint _120 = _96.x;
            _90 = _126._m0[(_120 * 3u) + 0u];
            _92 = _126._m0[(_120 * 3u) + 1u];
            _93 = _126._m0[(_120 * 3u) + 2u];
        }
        else
        {
            float _146 = _147.w * 255.100006103515625;
            vec4 _153;
            _153.y = _146 - (floor(_146 / 128.0) * 128.0);
            float _162 = _163.w * 255.100006103515625;
            _153.z = floor(_162 / 16.0);
            _153.w = _162 - (_153.z * 16.0);
            _153.y *= 0.00393700785934925079345703125;
            _153.z *= 0.02222222276031970977783203125;
            _153.w *= 0.01666666753590106964111328125;
            _153.x = 1.0 - ((_153.y + _153.z) + _153.w);
            for (uint _203 = 0u; _203 < 4u; _203++)
            {
                _90 += (_126._m0[(_96[_203] * 3u) + 0u] * _153[_203]);
            }
            for (uint _228 = 0u; _228 < 4u; _228++)
            {
                _92 += (_126._m0[(_96[_228] * 3u) + 1u] * _153[_228]);
            }
            for (uint _251 = 0u; _251 < 4u; _251++)
            {
                _93 += (_126._m0[(_96[_251] * 3u) + 2u] * _153[_251]);
            }
        }
        vec4 _274 = _88;
        vec4 _276 = _90;
        _65.x = _28(_274, _276);
        vec4 _280 = _88;
        vec4 _282 = _92;
        _65.y = _28(_280, _282);
        vec4 _286 = _88;
        vec4 _288 = _93;
        _65.z = _28(_286, _288);
        _65.w = 1.0;
    }
    mat4 _293 = mat4(vec4(_99._m1), vec4(_99._m2), vec4(_99._m3), vec4(_99._m4));
    mat4 _326 = mat4(vec4(_329._m0), vec4(_329._m1), vec4(_329._m2), vec4(_329._m3));
    mat4 _360 = _293;
    mat4 _362 = _326;
    mat4 _359 = _35(_360, _362);
    vec4 _365 = _359[0];
    vec4 _368 = _359[1];
    vec4 _371 = _359[2];
    vec4 _374 = _359[3];
    vec4 _381 = _65;
    vec4 _383 = _365;
    gl_Position.x = _28(_381, _383);
    vec4 _388 = _65;
    vec4 _390 = _368;
    gl_Position.y = _28(_388, _390);
    vec4 _394 = _65;
    vec4 _396 = _371;
    gl_Position.z = _28(_394, _396);
    vec4 _400 = _65;
    vec4 _402 = _374;
    gl_Position.w = _28(_400, _402);
    vec4 _407 = _65;
    vec4 _409 = _99._m1;
    vec4 _406;
    _406.x = _28(_407, _409);
    vec4 _414 = _65;
    vec4 _416 = _99._m2;
    _406.y = _28(_414, _416);
    vec4 _421 = _65;
    vec4 _423 = _99._m3;
    _406.z = _28(_421, _423);
    _406.w = 1.0;
    vec4 _429 = _406 - _329._m4;
    _435 = vec4(_438.x, _438.y, _443.x, _443.y);
    vec3 _449 = _67.xyz;
    _452 = vec4(0.0);
    vec3 _453 = (_99._m5.xyz - _449) * _99._m5.w;
    vec3 _463 = (_99._m6.xyz - _449) * _99._m6.w;
    vec3 _473 = (_99._m7.xyz - _449) * _99._m7.w;
    vec3 _483 = (_99._m8.xyz - _449) * _99._m8.w;
    vec3 _493 = (_99._m9.xyz - _449) * _99._m9.w;
    vec3 _503 = (_99._m10.xyz - _449) * _99._m10.w;
    vec3 _513 = (_99._m11.xyz - _449) * _99._m11.w;
    vec3 _523 = (_99._m12.xyz - _449) * _99._m12.w;
    vec3 _533 = (_99._m13.xyz - _449) * _99._m13.w;
    vec3 _543 = (_99._m14.xyz - _449) * _99._m14.w;
    vec3 _553 = (_99._m15.xyz - _449) * _99._m15.w;
    vec3 _563 = (_99._m16.xyz - _449) * _99._m16.w;
    vec3 _573 = (_99._m17.xyz - _449) * _99._m17.w;
    vec3 _583 = (_99._m18.xyz - _449) * _99._m18.w;
    vec3 _593 = (_99._m19.xyz - _449) * _99._m19.w;
    vec3 _603 = (_99._m20.xyz - _449) * _99._m20.w;
    vec3 _613 = (_99._m21.xyz - _449) * _99._m21.w;
    vec3 _623 = (_99._m22.xyz - _449) * _99._m22.w;
    vec3 _633 = (_99._m23.xyz - _449) * _99._m23.w;
    vec3 _643 = (_99._m24.xyz - _449) * _99._m24.w;
    vec3 _654 = _453;
    vec3 _656 = _453;
    float _653 = _17(_654, _656);
    vec3 _660 = _463;
    vec3 _662 = _463;
    float _659 = _17(_660, _662);
    vec3 _666 = _473;
    vec3 _668 = _473;
    float _665 = _17(_666, _668);
    vec3 _672 = _483;
    vec3 _674 = _483;
    float _671 = _17(_672, _674);
    vec3 _678 = _493;
    vec3 _680 = _493;
    float _677 = _17(_678, _680);
    vec3 _684 = _503;
    vec3 _686 = _503;
    float _683 = _17(_684, _686);
    vec3 _690 = _513;
    vec3 _692 = _513;
    float _689 = _17(_690, _692);
    vec3 _696 = _523;
    vec3 _698 = _523;
    float _695 = _17(_696, _698);
    vec3 _702 = _533;
    vec3 _704 = _533;
    float _701 = _17(_702, _704);
    vec3 _708 = _543;
    vec3 _710 = _543;
    float _707 = _17(_708, _710);
    vec3 _714 = _553;
    vec3 _716 = _553;
    float _713 = _17(_714, _716);
    vec3 _720 = _563;
    vec3 _722 = _563;
    float _719 = _17(_720, _722);
    vec3 _726 = _573;
    vec3 _728 = _573;
    float _725 = _17(_726, _728);
    vec3 _732 = _583;
    vec3 _734 = _583;
    float _731 = _17(_732, _734);
    vec3 _738 = _593;
    vec3 _740 = _593;
    float _737 = _17(_738, _740);
    vec3 _744 = _603;
    vec3 _746 = _603;
    float _743 = _17(_744, _746);
    vec3 _750 = _613;
    vec3 _752 = _613;
    float _749 = _17(_750, _752);
    vec3 _756 = _623;
    vec3 _758 = _623;
    float _755 = _17(_756, _758);
    vec3 _762 = _633;
    vec3 _764 = _633;
    float _761 = _17(_762, _764);
    vec3 _768 = _643;
    vec3 _770 = _643;
    float _767 = _17(_768, _770);
    float _773 = min(_653, _659);
    _773 = min(_773, _665);
    _773 = min(_773, _671);
    _773 = min(_773, _677);
    _773 = min(_773, _683);
    _773 = min(_773, _689);
    _773 = min(_773, _695);
    _773 = min(_773, _701);
    _773 = min(_773, _707);
    _773 = min(_773, _713);
    _773 = min(_773, _719);
    float _807 = min(_725, _731);
    _807 = min(_807, _737);
    _807 = min(_807, _743);
    _807 = min(_807, _749);
    _807 = min(_807, _755);
    _807 = min(_807, _761);
    _807 = min(_807, _767);
    float _829 = sqrt(min(_773, _807)) - 1.0;
    float _835 = sqrt(_773) - 1.0;
    _452 = vec4(_829, 0.0, 0.0, _835);
    vec2 _849 = _435.xy * _99._m25.xy;
    _842 = vec4(_849.x, _849.y, _842.z, _842.w);
    _842 = vec4(_842.x, _842.y, vec2(0.0).x, vec2(0.0).y);
    gl_Position.z -= 0.0001904999953694641590118408203125;
    mat4 _860 = mat4(vec4(_99._m1), vec4(_99._m2), vec4(_99._m3), vec4(_99._m4));
    mat4 _890 = mat4(vec4(_329._m5), vec4(_329._m6), vec4(_329._m7), vec4(_329._m8));
    mat4 _921 = _860;
    mat4 _923 = _890;
    mat4 _920 = _35(_921, _923);
    vec4 _926 = _920[0];
    vec4 _929 = _920[1];
    vec4 _932 = _920[2];
    vec4 _935 = _920[3];
    vec4 _938 = vec4(_67.xyz, 1.0);
    if (_76._m0.z != 0.0)
    {
        vec4 _950 = _938;
        vec4 _952 = vec4(0.0);
        vec4 _953 = vec4(0.0);
        vec4 _954 = vec4(0.0);
        uvec4 _955 = uvec4(uint(_99._m0.x + _76._m0.x)) + uvec4(_107 * 255.0);
        if (_76._m0.z == 1.0)
        {
            uint _972 = _955.x;
            _952 = _126._m0[(_972 * 3u) + 0u];
            _953 = _126._m0[(_972 * 3u) + 1u];
            _954 = _126._m0[(_972 * 3u) + 2u];
        }
        else
        {
            float _991 = _147.w * 255.100006103515625;
            vec4 _995;
            _995.y = _991 - (floor(_991 / 128.0) * 128.0);
            float _1003 = _163.w * 255.100006103515625;
            _995.z = floor(_1003 / 16.0);
            _995.w = _1003 - (_995.z * 16.0);
            _995.y *= 0.00393700785934925079345703125;
            _995.z *= 0.02222222276031970977783203125;
            _995.w *= 0.01666666753590106964111328125;
            _995.x = 1.0 - ((_995.y + _995.z) + _995.w);
            for (uint _1039 = 0u; _1039 < 4u; _1039++)
            {
                _952 += (_126._m0[(_955[_1039] * 3u) + 0u] * _995[_1039]);
            }
            for (uint _1062 = 0u; _1062 < 4u; _1062++)
            {
                _953 += (_126._m0[(_955[_1062] * 3u) + 1u] * _995[_1062]);
            }
            for (uint _1085 = 0u; _1085 < 4u; _1085++)
            {
                _954 += (_126._m0[(_955[_1085] * 3u) + 2u] * _995[_1085]);
            }
        }
        vec4 _1108 = _950;
        vec4 _1110 = _952;
        _938.x = _28(_1108, _1110);
        vec4 _1114 = _950;
        vec4 _1116 = _953;
        _938.y = _28(_1114, _1116);
        vec4 _1120 = _950;
        vec4 _1122 = _954;
        _938.z = _28(_1120, _1122);
        _938.w = 1.0;
    }
    vec4 _1128 = _938;
    vec4 _1130 = _926;
    vec4 _1127;
    _1127.x = _28(_1128, _1130);
    vec4 _1134 = _938;
    vec4 _1136 = _929;
    _1127.y = _28(_1134, _1136);
    vec4 _1140 = _938;
    vec4 _1142 = _932;
    _1127.z = _28(_1140, _1142);
    vec4 _1146 = _938;
    vec4 _1148 = _935;
    _1127.w = _28(_1146, _1148);
    _1152 = _1127;
    mat4 _1154 = mat4(vec4(_99._m26), vec4(_99._m27), vec4(_99._m28), vec4(_99._m29));
    mat4 _1188 = mat4(vec4(_329._m9), vec4(_329._m10), vec4(_329._m11), vec4(_329._m12));
    mat4 _1219 = _1154;
    mat4 _1221 = _1188;
    mat4 _1218 = _35(_1219, _1221);
    vec4 _1224 = _1218[0];
    vec4 _1227 = _1218[1];
    vec4 _1230 = _1218[2];
    vec4 _1233 = _1218[3];
    vec4 _1236 = vec4(_67.xyz, 1.0);
    if (_76._m0.z != 0.0)
    {
        vec4 _1248 = _1236;
        vec4 _1250 = vec4(0.0);
        vec4 _1251 = vec4(0.0);
        vec4 _1252 = vec4(0.0);
        uvec4 _1253 = uvec4(uint(_99._m0.y + _76._m0.y)) + uvec4(_107 * 255.0);
        if (_76._m0.z == 1.0)
        {
            uint _1270 = _1253.x;
            _1250 = _126._m0[(_1270 * 3u) + 0u];
            _1251 = _126._m0[(_1270 * 3u) + 1u];
            _1252 = _126._m0[(_1270 * 3u) + 2u];
        }
        else
        {
            float _1289 = _147.w * 255.100006103515625;
            vec4 _1293;
            _1293.y = _1289 - (floor(_1289 / 128.0) * 128.0);
            float _1301 = _163.w * 255.100006103515625;
            _1293.z = floor(_1301 / 16.0);
            _1293.w = _1301 - (_1293.z * 16.0);
            _1293.y *= 0.00393700785934925079345703125;
            _1293.z *= 0.02222222276031970977783203125;
            _1293.w *= 0.01666666753590106964111328125;
            _1293.x = 1.0 - ((_1293.y + _1293.z) + _1293.w);
            for (uint _1337 = 0u; _1337 < 4u; _1337++)
            {
                _1250 += (_126._m0[(_1253[_1337] * 3u) + 0u] * _1293[_1337]);
            }
            for (uint _1360 = 0u; _1360 < 4u; _1360++)
            {
                _1251 += (_126._m0[(_1253[_1360] * 3u) + 1u] * _1293[_1360]);
            }
            for (uint _1383 = 0u; _1383 < 4u; _1383++)
            {
                _1252 += (_126._m0[(_1253[_1383] * 3u) + 2u] * _1293[_1383]);
            }
        }
        vec4 _1406 = _1248;
        vec4 _1408 = _1250;
        _1236.x = _28(_1406, _1408);
        vec4 _1412 = _1248;
        vec4 _1414 = _1251;
        _1236.y = _28(_1412, _1414);
        vec4 _1418 = _1248;
        vec4 _1420 = _1252;
        _1236.z = _28(_1418, _1420);
        _1236.w = 1.0;
    }
    vec4 _1426 = _1236;
    vec4 _1428 = _1224;
    vec4 _1425;
    _1425.x = _28(_1426, _1428);
    vec4 _1432 = _1236;
    vec4 _1434 = _1227;
    _1425.y = _28(_1432, _1434);
    vec4 _1438 = _1236;
    vec4 _1440 = _1230;
    _1425.z = _28(_1438, _1440);
    vec4 _1444 = _1236;
    vec4 _1446 = _1233;
    _1425.w = _28(_1444, _1446);
    _1450 = _1425;
    vec4 _1452 = vec4(_67.xyz, 1.0);
    vec4 _1459 = (_163 * 2.0) - vec4(1.0);
    vec4 _1465 = (_147 * 2.0) - vec4(1.0);
    _1465.w = (floor((_147.w * 255.100006103515625) / 128.0) * 2.0) - 1.0;
    float _1478 = 0.0;
    if (_76._m0.z != 0.0)
    {
        vec4 _1484 = _1452;
        vec4 _1486 = vec4(0.0);
        vec4 _1487 = vec4(0.0);
        vec4 _1488 = vec4(0.0);
        uvec4 _1489 = uvec4(uint(_99._m0.x + _76._m0.x)) + uvec4(_107 * 255.0);
        if (_76._m0.z == 1.0)
        {
            uint _1506 = _1489.x;
            _1486 = _126._m0[(_1506 * 3u) + 0u];
            _1487 = _126._m0[(_1506 * 3u) + 1u];
            _1488 = _126._m0[(_1506 * 3u) + 2u];
        }
        else
        {
            float _1525 = _147.w * 255.100006103515625;
            vec4 _1529;
            _1529.y = _1525 - (floor(_1525 / 128.0) * 128.0);
            float _1537 = _163.w * 255.100006103515625;
            _1529.z = floor(_1537 / 16.0);
            _1529.w = _1537 - (_1529.z * 16.0);
            _1529.y *= 0.00393700785934925079345703125;
            _1529.z *= 0.02222222276031970977783203125;
            _1529.w *= 0.01666666753590106964111328125;
            _1529.x = 1.0 - ((_1529.y + _1529.z) + _1529.w);
            for (uint _1573 = 0u; _1573 < 4u; _1573++)
            {
                _1486 += (_126._m0[(_1489[_1573] * 3u) + 0u] * _1529[_1573]);
            }
            for (uint _1596 = 0u; _1596 < 4u; _1596++)
            {
                _1487 += (_126._m0[(_1489[_1596] * 3u) + 1u] * _1529[_1596]);
            }
            for (uint _1619 = 0u; _1619 < 4u; _1619++)
            {
                _1488 += (_126._m0[(_1489[_1619] * 3u) + 2u] * _1529[_1619]);
            }
        }
        vec4 _1642 = _1484;
        vec4 _1644 = _1486;
        _1452.x = _28(_1642, _1644);
        vec4 _1648 = _1484;
        vec4 _1650 = _1487;
        _1452.y = _28(_1648, _1650);
        vec4 _1654 = _1484;
        vec4 _1656 = _1488;
        _1452.z = _28(_1654, _1656);
        _1452.w = 1.0;
        vec4 _1661 = _1459;
        vec4 _1663 = _1661;
        vec4 _1665 = _1486;
        _1459.x = _24(_1663, _1665);
        vec4 _1669 = _1661;
        vec4 _1671 = _1487;
        _1459.y = _24(_1669, _1671);
        vec4 _1675 = _1661;
        vec4 _1677 = _1488;
        _1459.z = _24(_1675, _1677);
        vec4 _1681 = _1465;
        vec4 _1683 = _1681;
        vec4 _1685 = _1486;
        _1465.x = _24(_1683, _1685);
        vec4 _1689 = _1681;
        vec4 _1691 = _1487;
        _1465.y = _24(_1689, _1691);
        vec4 _1695 = _1681;
        vec4 _1697 = _1488;
        _1465.z = _24(_1695, _1697);
    }
    float _1701 = length(_99._m30.xyz - _1452.xyz);
    float _1720 = abs(_1701 - _99._m31.z) / _99._m31.x;
    float _1710 = 1.0 - _10(_1720);
    float _1723 = ((_1710 * _1710) * _99._m31.y) * 0.00999999977648258209228515625;
    _1452 += (_1459 * vec4(_1723, _1723, _1723, 0.0));
    mat4 _1740 = mat4(vec4(_99._m1), vec4(_99._m2), vec4(_99._m3), vec4(_99._m4));
    mat4 _1770 = mat4(vec4(_329._m0), vec4(_329._m1), vec4(_329._m2), vec4(_329._m3));
    mat4 _1801 = _1740;
    mat4 _1803 = _1770;
    mat4 _1800 = _35(_1801, _1803);
    vec4 _1806 = _1800[0];
    vec4 _1809 = _1800[1];
    vec4 _1812 = _1800[2];
    vec4 _1815 = _1800[3];
    vec4 _1818 = _1452;
    vec4 _1820 = _1806;
    gl_Position.x = _28(_1818, _1820);
    vec4 _1824 = _1452;
    vec4 _1826 = _1809;
    gl_Position.y = _28(_1824, _1826);
    vec4 _1830 = _1452;
    vec4 _1832 = _1812;
    gl_Position.z = _28(_1830, _1832);
    vec4 _1836 = _1452;
    vec4 _1838 = _1815;
    gl_Position.w = _28(_1836, _1838);
    vec4 _1842 = vec4(_438, _1844);
    _1851 = _1842 + _76._m1;
    gl_Position.y = -gl_Position.y;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
//gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y);
//return;

// This does not work
    // Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
    if(vk3d_params[VIEW].custom_params.z != 0)
    {
        if (gl_Position.w > vk3d_params[VIEW].custom_params.z)
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
        else
            gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].custom_params.w) *0.75;
    }
    else
    {
        gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y); 
    }
}





